<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 25/08/2017
 * Time: 10:22
 */
namespace HCM\Geral\Factory;

use Doctrine\ORM\EntityManager;
use HCM\Geral\Repository\ESocialEventoPeriodRepository;
use HCM\Geral\Repository\Esocial\S1210Repository;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;

class ESocialPeriodFactory {

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ESocialEventoPeriodRepository $eSocialEventoPeriodRepository, S1210Repository $s1210Repository)
    {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->eSocialEventoPeriodRepository = $eSocialEventoPeriodRepository;
        $this->s1210 = $s1210Repository;
        
        $this->temp = false;
    }
    
    
    /* Evento S-1200 */
    public function getDadosS1200($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200(
                $parametros['NRESTRUTURAM'], $parametros['NRCHAVE'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC'], $parametros['NRTPAMBIENTE']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200remunOutrEmpr($parametros) {
        try {
            if (!is_null($parametros['INDMV'])) {
                $dados = $this->eSocialEventoPeriodRepository->getDadosS1200remunOutrEmpr(
                    $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA']
                );
            } else {
                $dados = array();
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200procJudTrab($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200procJudTrab($parametros['NRORG'], $parametros['NRESTRUTLEGAL'], $parametros['NRPARCNEGOCIO']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200dmDev($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200dmDev(
                $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200ideEstabLot($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200ideEstabLot(
                $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['CDCATEGTRAB'], $parametros['INFOPERAPUR'], $parametros['INFOPERANT']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200remunPerApur($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200remunPerApur(
                $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['CDCATEGTRAB']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200itensRemun($parametros) {  
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200itensRemun($parametros['NRORG'], $parametros['NRVINCULOM'], $parametros['NRCALCULOFOLHA']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200detOper($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200detOper($parametros['NRORG'], $parametros['NRVINCULOM'], $parametros['NRCALCULOFOLHA']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200detPlano($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200detPlano(
                $parametros['NRORG'], $parametros['NRVINCULOM'], $parametros['NRCALCULOFOLHA'], $parametros['CDCNPJESTRUT']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200ideADC($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200ideADC(
                $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['CDCATEGTRAB']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200idePeriodo($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200idePeriodo(
                $parametros['NRORG'], $parametros['NRVINCULOM'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['CDCATEGTRAB']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1200remunPerAnt($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1200remunPerAnt(
                $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['CDCATEGTRAB']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    /* Evento S-1210 */
    public function getDadosS1210($parametros) {
        try {
            $temp = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->findOneBy(array('nrorg' => $parametros['NRORG'], 'nrestruturam' => $parametros['NRESTRUTURAM']));
            if ($temp && $temp->getCdintestrutexp() == '1210') {
                $dados = $this->s1210->getDadosS1210(
                    $parametros['NRESTRUTURAM'], $parametros['NRCHAVE'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC'], $parametros['NRTPAMBIENTE']
                );
                $this->temp = true;
            } else {
                $dados = $this->eSocialEventoPeriodRepository->getDadosS1210(
                    $parametros['NRESTRUTURAM'], $parametros['NRCHAVE'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC'], $parametros['NRTPAMBIENTE']
                );
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210infoPgto($parametros) {
        try {
            if ($this->temp) {
                if ($parametros['IDTRANSFERENCIA'] == 'E') {
                    $dados = $this->s1210->getDadosS1210infoPgto_transfEntr($parametros);
                } else if ($parametros['IDTRANSFERENCIA'] == 'S') {
                    $dados = $this->s1210->getDadosS1210infoPgto_transfSaid($parametros);
                } else {
                    $dados = $this->s1210->getDadosS1210infoPgto_semTransf($parametros);
                }
            } else {
                $funcionario = $this->eSocialEventoPeriodRepository->getDadosS1210VerificaMovimentacao($parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC']);
                if ($funcionario['NRTPMOVTRANSFM'] == '8') {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210infoPgtoTransfSaid(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['INIVALIDADEAMB'], $funcionario['NRTPMOVTRANSFM']
                    );
                } else if ($funcionario['NRTPMOVTRANSFM'] == '9') {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210infoPgtoTransfEntr(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['INIVALIDADEAMB'], $funcionario['NRTPMOVTRANSFM']
                    );
                } else {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210infoPgtoSemTransf(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['INIVALIDADEAMB'], $funcionario['NRTPMOVTRANSFM']
                    );
                }
                /*$dados = $this->eSocialEventoPeriodRepository->getDadosS1210infoPgto(
                    $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['INIVALIDADEAMB']
                );*/
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210detPgtoFl($parametros) {
        try {
            /* getDadosS1210infoPgto::TPPGTO
             * 1 - Pagamento de remuneração, conforme apurado em {dmDev} do S-1200;
             * 2 - Pagamento de verbas rescisórias conforme apurado em {dmDev} do S-2299;
             * 3 - Pagamento de verbas rescisórias conforme apurado em {dmDev} do S-2399;
             */
            if ($parametros['TPPGTO'] == '1' || $parametros['TPPGTO'] == '2' || $parametros['TPPGTO'] == '3') {
                if ($parametros['NRTPMOVTRANSFM'] == '8') {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210detPgtoFlTransfSaid(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['TPPGTO'], $parametros['INIVALIDADEAMB'], $parametros['DTOCORRECALC'], $parametros['NRTPMOVTRANSFM']
                    );
                } else if ($parametros['NRTPMOVTRANSFM'] == '9') {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210detPgtoFlTransfEntr(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['TPPGTO'], $parametros['INIVALIDADEAMB'], $parametros['DTOCORRECALC'], $parametros['NRTPMOVTRANSFM']
                    );
                } else {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210detPgtoFlSemTransf(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['TPPGTO'], $parametros['INIVALIDADEAMB'], $parametros['DTOCORRECALC'], $parametros['NRTPMOVTRANSFM']
                    );
                }
                /*$dados = $this->eSocialEventoPeriodRepository->getDadosS1210detPgtoFl(
                    $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['TPPGTO'], $parametros['INIVALIDADEAMB'], $parametros['DTOCORRECALC']
                );*/
                return $dados;
            } else {
                return array();
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210retPgtoTot($parametros) {
        try {
            if (isset($parametros['NRCALCULOFOLHA'])) {
                if ($parametros['NRTPMOVTRANSFM'] == '8') {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210retPgtoTotTransfSaid(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['NRTIPOMOVIMENT'], $parametros['NRTPMOVTRANSFM']
                    );
                } else if ($parametros['NRTPMOVTRANSFM'] == '9') {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210retPgtoTotTransfEntr(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['NRTIPOMOVIMENT'], $parametros['NRTPMOVTRANSFM']
                    );
                } else {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210retPgtoTotSemTransf(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['NRTIPOMOVIMENT'], $parametros['NRTPMOVTRANSFM']
                    );
                }
                /*$dados = $this->eSocialEventoPeriodRepository->getDadosS1210retPgtoTot(
                    $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['NRTIPOMOVIMENT']
                );*/
                return $dados;
            } else {
                return array();
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210penAlim($parametros) {
        try {
            if (isset($parametros['NRTPMOVTRANSFM'])) {
                if ($parametros['NRTPMOVTRANSFM'] == '8') {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210penAlimTransfSaid(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['NREVENTOM'], $parametros['NRTPMOVTRANSFM']
                    );
                } else if ($parametros['NRTPMOVTRANSFM'] == '9') {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210penAlimTransfEntr(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['NREVENTOM'], $parametros['NRTPMOVTRANSFM']
                    );
                } else {
                    $dados = $this->eSocialEventoPeriodRepository->getDadosS1210penAlimSemTransf(
                        $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['NREVENTOM'], $parametros['NRTPMOVTRANSFM']
                    );
                }
            } else {
                $dados = $this->eSocialEventoPeriodRepository->getDadosS1210penAlim(
                    $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA'], $parametros['NREVENTOM']
                );
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210detPgtoFer($parametros) {
        try {
            /* getDadosS1210infoPgto::TPPGTO
             * 7 - Recibo de férias;
             */
            if ($parametros['TPPGTO'] == '7') {
                $dados = $this->eSocialEventoPeriodRepository->getDadosS1210detPgtoFer(
                    $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['DTOCORRENCIA']
                );
                return $dados;
            } else {
                return array();
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210detRubrFer($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1210detRubrFer(
                $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRCALCULOFOLHA']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210detPgtoAnt($parametros) {
        try {
            /* getDadosS1210infoPgto::TPPGTO
             * 9 - Pagamento relativo a competências anteriores ao início de obrigatoriedade dos eventos periódicos para o contribuinte;
             */
            if ($parametros['TPPGTO'] == '9') {
                $dados = $this->eSocialEventoPeriodRepository->getDadosS1210detPgtoAnt(
                    $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['INIVALIDADEAMB']
                );
                return $dados;
            } else {
                return array();
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210infoPgtoAnt($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1210infoPgtoAnt(
                $parametros['NRORG'], $parametros['NRPESSOA'], $parametros['NRINSCRICAOPARC'], $parametros['CODCATEG'], $parametros['NRTABELA'], $parametros['DTOCORRENCIA'], $parametros['NRTPAMBIENTE'], $parametros['INIVALIDADEAMB']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    /* Evento S-1250 */
    public function getDadosS1250($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1250(
                $parametros['NRCHAVE'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1250tpAquis($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1250tpAquis(
                $parametros['NRCHAVE']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1250ideProdutor($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1250ideProdutor(
                $parametros['NRESTRUTESTAB'], $parametros['INDAQUIS']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    /* Evento S-1280 */
    public function getDadosS1280($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1280(
                $parametros['NRCHAVE'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    /* Evento S-1295 */
    public function getDadosS1295($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1295(
                $parametros['NRESTRUTURAM'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    /* Evento S-1298 */
    public function getDadosS1298($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1298(
                $parametros['NRESTRUTURAM'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    /* Evento S-1299 */
    public function getDadosS1299($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1299(
                $parametros['NRESTRUTURAM'], $parametros['NRCHAVE'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC'], $parametros['NRTPAMBIENTE'], $parametros['IDFECHASMOVIMENT']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    /* Evento S-1300 */
    public function getDadosS1300($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1300(
                $parametros['NRESTRUTURAM'], $parametros['NRTABELA'], $parametros['DTMESCOMPETENC']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1300contribSind($parametros) {
        try {
            $dados = $this->eSocialEventoPeriodRepository->getDadosS1300contribSind(
                $parametros['NRORG'], $parametros['NRESTRUTURAM'], $parametros['NRCALCULOFOLHA']
            );
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

}