<?php
namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class EsoSimplificadoService {
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function beforeDeleteEvento($row) {
        try {
            if ($row['NMEVENTO'] == 'S-3000' || $row['IDOPERACAO'] == 'E' || $row['IDOPERACAO'] == 'R') {
                $enviosOrig = $this->entityManager->getRepository(Repositories::ESO_NAOPERIODICO)->findBy(array('nrorg' => $row['NRORG'], 'nrenvioexcl' => $row['NRENVIO']));

                foreach ($enviosOrig as $envioOrig) {
                    $envioOrig->setNrenvioexcl();
                    $this->entityManager->persist($envioOrig);
                    $this->entityManager->flush();
                }
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function inativaEvento($nrorg, $nrenvio){
        $evento = $this->entityManager->getRepository(Repositories::ESO_NAOPERIODICO)->findBy(array('nrorg' => $row['NRORG'], 'nrenvioexcl' => $row['NRENVIO']));
        if ($evento) {
            $evento->setIdativo('N');
            $evento->setDtultatu(DateUtil::getDataAtual());
            $evento->setCdoperultatu($this->hcmParameters->getCdoperador());
            $evento->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $this->entityManager->persist($evento);
            $this->entityManager->flush();
        }
    }

}