<?php

namespace Relatione\Logic;

class AnexosCrmLogic
{   

//Recebe o NRORG, NRSEQEVOLCONT, e os Nome dos Arquivos a serem deletados,  os arquivos vão ser lidos como checkbox, é  dado um explode nesse nome, e o diretório salvo na tabela PARARELATIONE é concatenado dentro de um foreach com cada array gerado pelo explode, e assim os arquivos são eliminados um a um.

public static function deletaAnexoCRM($nrorg, $nrseqevolcont, $nomeArquivos) 
    {
      if(self::caminhoDiretorioCRM($nrorg) != 'N')
      {
        $caminho = realpath(self::caminhoDiretorioCRM($nrorg));
        $caminho = $caminho.DIRECTORY_SEPARATOR.'Contato_'.$nrorg.DIRECTORY_SEPARATOR.$nrseqevolcont;
        @self::deletaAntigosAnexosCRM($nrorg, $nomeArquivos);
        $nomeArquivos = explode(',',$nomeArquivos);

        if(is_dir($caminho)==true) 
        {
            if ((tk_get_env_var('PASTAS_EVOL')==true)||(count(scandir($caminho))<=(count($nomeArquivos)+2)))
            {
              $sql = 'SELECT * FROM EVOLCONT WHERE NRORG = :NRORG AND NRCONTATO = :NRCONTATO AND CDFILIAL = :CDFILIAL AND NRSEQEVOLCONT = :NRSEQEVOLCONT';
              $params = array('NRORG'=>$nrorg, 'NRCONTATO'=>tk_get_field_value('NRCONTATO'), 'CDFILIAL'=>tk_get_field_value('CDFILIAL'), 'NRSEQEVOLCONT'=>$nrseqevolcont);
              $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql,$params);

              if (((count($retorno)>0) && ($retorno[0]['IDANEXOEVOLCONT']!== 'N'))&&(strlen(tk_get_env_var("LISTA_ARQ2"))<1)) 
              {
                $dt = now();
   
                $sql = 'UPDATE EVOLCONT
                           SET IDANEXOEVOLCONT = \'N\', 
                               NRORGULTATU = :NRORGULTATU,
                               DTULTATU = :DTULTATU,
                               CDOPERULTATU = :CDOPERULTATU
                         WHERE NRCONTATO = :NRCONTATO
                           AND CDFILIAL = :CDFILIAL
                           AND NRORG = :NRORG
                           AND NRSEQEVOLCONT = :NRSEQEVOLCONT';
                $update = array('NRORGULTATU'=>$nrorg, 'DTULTATU'=>$dt, 'CDOPERULTATU'=>\Geral\Util\Ambiente::getCdoperador(), 'NRCONTATO'=>tk_get_field_value('NRCONTATO'), 'CDFILIAL'=>tk_get_field_value('CDFILIAL'), 'NRORG'=>$nrorg, 'NRSEQEVOLCONT'=>$nrseqevolcont);
                          
                \Setforms2\Runtime\Connection::getInstance()->execute($sql, $update);    
              }
              @self::ExcluiPastaAnexo($caminho);
            }
            else
            {
              foreach($nomeArquivos as $nome)
              {
                $caminhoCompleto = $caminho.DIRECTORY_SEPARATOR.$nome;
                if(is_file($caminhoCompleto)===true)
                {
                  chmod($caminhoCompleto,0775);
                  unlink($caminhoCompleto);
                }
              }
            }
            tk_set_env_var('PASTAS_EVOL',false);
        }
        tk_message('Anexo(s) removido(s) com sucesso!');
        self::atualizaAnexosCRM($nrseqevolcont);
        tk_reload_data_with_filter();
        return true;
      }
    }

//Função para deletar os anexos com a chave antiga, chave que tinha, NRORG_CDFILIAL_NRCONTATO_DTHREVOLCONT, pórem só deleta os anexos contidos na pasta parametrizada, na parametrização de CRM.

  public static function deletaAntigosAnexosCRM($nrorg, $nomeArquivos) {
      if(self::caminhoDiretorioCRM($nrorg) != 'N')
      {
          $caminho = realpath(\Setforms2\Shared\Config::getInstance()->getProjectCaminhoDir());
          
            $nomeArquivos = explode(',',$nomeArquivos);
         
            foreach($nomeArquivos as $nome)
            {

                $caminhoCompleto = $caminho.DIRECTORY_SEPARATOR.$nome;

                chmod($caminhoCompleto,0775);
                unlink($caminhoCompleto);
            }
      }
      return true;
    }

//Prepara o nome que vai identificar a qual evolução o arquivo anexado pertence, ela concatena o NRORG_NRSEQEVOLCONT_.
    public static function preparaNomeAnexoCRM($nrorg, $nrseqevolcont){

      $dthranexo = now();
      $dthranexo = str_replace(' ','_',$dthranexo);
      $dthranexo = str_replace('/','-',$dthranexo);
      $dthranexo = str_replace(':','.',$dthranexo);
        $nome_arquivo = $nrorg.'_'.$nrseqevolcont.'_'.$dthranexo;
        return $nome_arquivo;
    }

  //Recebe o nrorg e busca na tabela PARARELATIONE e retorna para o usuario o diretorio de anexo cadastrado.
    public static function caminhoDiretorioCRM($nrorg)
  {
    $sql = 'SELECT * FROM PARARELATIONE WHERE NRORG = :NRORG';
        $params = array('NRORG'=>$nrorg);
        $diretorio = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql,$params);
        if(count($diretorio)>0)
          {$caminho = $diretorio[0]['DSDIRANEXOCONT'];}
        else
          {$caminho = 'N';}
        return $caminho;
  }
   
//Recebe NRORG e NRSEQEVOLCONT. Na função é feito a chamada da preparaNomeAnexoCRM, para montar o 'nome chave' do arquivo anexado. Ao terminar de montar o arquivo este é transferido para o diretório parametrizado na tela de parametrização do CRM.
    public static function incluiAnexosEvolucaoCRM($nrorg, $nrseqevolcont) {
        try {
          
          $nome_arquivo = @self::preparaNomeAnexoCRM($nrorg, $nrseqevolcont);

          $nome = tk_get_uploaded_file_name();
          $nome_arquivo = $nome_arquivo.'_'.$nome;
          $nome_arquivo_novo = strtr(utf8_decode($nome_arquivo), utf8_decode("áàãâéêíóôõúüçÁÀÃÂÉÊÍÓÔÕÚÜÇ "), "aaaaeeiooouucAAAAEEIOOOUUC_");
          $nome_arquivo_novo = utf8_encode($nome_arquivo_novo);

          $diretorio = realpath(@self::caminhoDiretorioCRM($nrorg));
          $diretorio = $diretorio.DIRECTORY_SEPARATOR.'Contato_'.$nrorg.DIRECTORY_SEPARATOR.$nrseqevolcont;

          $valid = file_exists($diretorio);
    
          if($valid === false){
            mkdir($diretorio, 0777, true);
          }
          
          $dt = now();
          
          rename(realpath(APP_PATH.DIRECTORY_SEPARATOR.'uploads').DIRECTORY_SEPARATOR.$nome, $diretorio.DIRECTORY_SEPARATOR.$nome_arquivo_novo);
          chmod($diretorio.DIRECTORY_SEPARATOR.$nome_arquivo_novo, 0775);

          $sql = 'UPDATE EVOLCONT
                     SET IDANEXOEVOLCONT = \'S\', 
                         NRORGULTATU = :NRORGULTATU,
                         DTULTATU = :DTULTATU,
                         CDOPERULTATU = :CDOPERULTATU
                   WHERE NRCONTATO = :NRCONTATO
                     AND CDFILIAL = :CDFILIAL
                     AND NRORG = :NRORG
                     AND NRSEQEVOLCONT = :NRSEQEVOLCONT';
          $update = array('NRORGULTATU'=>$nrorg, 'DTULTATU'=>$dt, 'CDOPERULTATU'=>\Geral\Util\Ambiente::getCdoperador(), 'NRCONTATO'=>tk_get_field_value('NRCONTATO'), 'CDFILIAL'=>tk_get_field_value('CDFILIAL'), 'NRORG'=>$nrorg, 'NRSEQEVOLCONT'=>$nrseqevolcont);
          \Setforms2\Runtime\Connection::getInstance()->execute($sql, $update);
              return true;
          } 
          catch (\Exception $e) {
              tk_warning($e->getMessage());
              return false;
          }
      }
   
    public static function apagarPastaTempCRM()
    {
        $temp = $_SERVER['DOCUMENT_ROOT'].DIRECTORY_SEPARATOR.'temp'.DIRECTORY_SEPARATOR.\Geral\Util\Ambiente::getCdoperador();
        @self::ExcluiPastaAnexo($temp);
    }

    /* Atualiza os arquivos relacionados aos 'nomes chaves' atraves de um explode dado no nome do arquivo, para obter as chaves de NRORG e NRSEQEVOLCONT, a partir desse ponto é mostrado somente os arquivos correspodentes as chaves. Além desse "filtro", essa função também monta o link HTML do arquivo, para visualizar o anexo pelo navegador. */
    public static function atualizaAnexosCRM($nrseqevolcont){
    
      $sql = 'SELECT * FROM EVOLCONT WHERE NRCONTATO = :NRCONTATO AND NRSEQEVOLCONT = :NRSEQEVOLCONT' ;
      $params = array('NRCONTATO'=>tk_get_field_value('NRCONTATO'),'NRSEQEVOLCONT'=>$nrseqevolcont);
      $validacao = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql,$params);
      @self::apagarPastaTempCRM();
      if(count($validacao)>0)
      {
          $nrorg = \Geral\Util\Ambiente::getNrorg();
          $dthranexo = now();
          $dthranexo = str_replace(' ','_',$dthranexo);
          $dthranexo = str_replace('/','-',$dthranexo);
          $dthranexo = str_replace(':','.',$dthranexo);

          $chave = $nrorg.'_'.$nrseqevolcont.'_';
          
          $dir_anexo = realpath(self::caminhoDiretorioCRM($nrorg));
          $dir_anexo = $dir_anexo.DIRECTORY_SEPARATOR.'Contato_'.$nrorg.DIRECTORY_SEPARATOR.$nrseqevolcont;

          $temp = $_SERVER['DOCUMENT_ROOT'].DIRECTORY_SEPARATOR.'temp'.DIRECTORY_SEPARATOR.\Geral\Util\Ambiente::getCdoperador();

          if((is_dir($dir_anexo))&&(!is_dir($temp)))
            {mkdir($temp, 0777, true);} 

          $arquivos = '';
          $link = \Setforms2\Shared\Config::getInstance()->getProjectCaminhoDir();
          $dir_caminho = DIRECTORY_SEPARATOR.'temp'.DIRECTORY_SEPARATOR.\Geral\Util\Ambiente::getCdoperador();

          if (is_dir($dir_anexo) === true) {
              $dir_obj = new \DirectoryIterator($dir_anexo);
              
              foreach ($dir_obj as $file) {
                  if (!is_dir($file)) {
                      $nome_arquivo = $file->getFilename();

                      if($nome_arquivo != "Thumbs.db"){
                          $chavearq = explode('_', $nome_arquivo);
                          $nome_view = $chavearq[0].'_'.$chavearq[1].'_'.$chavearq[2].'_'.$chavearq[3].'_';
                          @$chavearq = $chavearq[0].'_'.$chavearq[1].'_';
                          copy($dir_anexo.DIRECTORY_SEPARATOR.$nome_arquivo, $temp.DIRECTORY_SEPARATOR.$nome_arquivo);
                          $short_name = str_replace($nome_view, "", $nome_arquivo);
                          $short_name = str_replace("_"," ",$short_name);
                          if ($chavearq == $chave){
                              $arquivos .= '<div class="cols-2-8 sameline"><input onclick="$(this).is(\':checked\') ? $(this).attr(\'marcado\', \'s\') : $(this).attr(\'marcado\', \'n\')" class="tk-extra-fields" type="checkbox" value="'.DIRECTORY_SEPARATOR.$nome_arquivo.'" name="checkArquivo[]" marcado="n"><a href="'.$dir_caminho.DIRECTORY_SEPARATOR.$nome_arquivo.'" target="_blank">'.$short_name.'</a> <br /></div>';
                              $listArq = tk_get_field_value("LISTA_ARQ");
                              tk_set_context_vars("LISTA_ARQ",tk_get_active_window_name(),$arquivos);
                          }
                      }
                  }
              }
          }
        @self::buscaAntigosAnexosCRM();
        tk_set_field_value('LISTA_ARQ', $arquivos); 
          return true;
      }
    }

    //Função para buscar os anexos com a chave antiga, chave que tinha, NRORG_CDFILIAL_NRCONTATO_DTHREVOLCONT, pórem só busca os anexos contidos na pasta parametrizada na parametrização de CRM.
    public static function buscaAntigosAnexosCRM()
    {
        $nrorg     = \Geral\Util\Ambiente::getNrorg();
        $filial    = tk_get_field_value('CDFILIAL');
        $nrContato = tk_get_field_value('NRCONTATO');
        $dthora    = tk_get_field_value('DTHREVOLCONT');
        if($dthora == null)
        {
        $dthora = now();
        tk_set_field_value('DTHREVOLCONT',$dthora);
        }
        $dthoraTrat = explode('/', substr($dthora, 0, 10));
        $dthoraTrat = $dthoraTrat[2].$dthoraTrat[1].$dthoraTrat[0];
        $dthoraTrat = $dthoraTrat.substr($dthora, 11);
        $dthoraTrat = preg_replace('/\D/', "", $dthoraTrat);
        $chave = $nrorg.'_'.$filial.'_'.$nrContato.'_'.$dthoraTrat.'_';
        
        $arquivos = '';
        $link = \Setforms2\Shared\Config::getInstance()->getProjectCaminhoDir();
        $dir_caminho = \Setforms2\Shared\Config::getInstance()->getProjectContatoDir();
		$temp = $_SERVER['DOCUMENT_ROOT'].DIRECTORY_SEPARATOR.'temp'.DIRECTORY_SEPARATOR.\Geral\Util\Ambiente::getCdoperador();

        if((is_dir($link))&&(!is_dir($temp)))
           {mkdir($temp, 0777, true);} 
        
        $dir_temp = DIRECTORY_SEPARATOR.'temp'.DIRECTORY_SEPARATOR.\Geral\Util\Ambiente::getCdoperador();   

        $contador = 0;
        try{
        if (is_dir($link) === true) {
            $dir_obj = new \DirectoryIterator($link);

            foreach ($dir_obj as $file) {
              $contador++;
              if ($file->isFile()==true) {
                
                $nome_arquivo = $file->getFilename();

                    if(($nome_arquivo != "Thumbs.db")&&(!is_dir($nome_arquivo))){
                        $chavearq = explode('_', $nome_arquivo);
                        $chavearq = $chavearq[0].'_'.$chavearq[1].'_'.$chavearq[2].'_'.$chavearq[3].'_';

                        $short_name = str_replace($chavearq, "", $nome_arquivo);
                        $short_name = str_replace("_"," ",$short_name);
                        if ($chavearq ==$chave){
                            copy($link.DIRECTORY_SEPARATOR.$nome_arquivo, $temp.DIRECTORY_SEPARATOR.$nome_arquivo);
						$arquivos .= '<div class="cols-2-8 sameline"><input onclick="$(this).is(\':checked\') ? $(this).attr(\'marcado\', \'s\') : $(this).attr(\'marcado\', \'n\')" class="tk-extra-fields" type="checkbox" value="'.DIRECTORY_SEPARATOR.$nome_arquivo.'" name="checkArquivo[]" marcado="n"><a href="'.$dir_temp.DIRECTORY_SEPARATOR.$nome_arquivo.'" target="_blank">'.$short_name.'</a> <br /></div>';
                            $listArq = tk_get_field_value("LISTA_ARQ2");

                            
                            //tk_set_context_vars("LISTA_ARQ2",tk_get_active_window_name(),$arquivos);
                        }
                    }
                }
            }
        tk_set_env_var('LISTA_ARQ2',$arquivos);
        tk_set_field_value('LISTA_ARQ2', $arquivos); 
        return true;
    }
    }
    catch (\Exception $e) {
              tk_warning($contador);
              tk_warning($e->getMessage());
              return false;
          }
}


//  É uma função que tem como objetivo estabelecer um tempo limite para o upload, é nela que é chamada a função incluiAnexosEvolucaoCRM e se esta retornar true, a função atualizaAnexosCRM para atualizar o anexos.
    public static function anexarArquivosCRM($nrorg, $nrseqevolcont){
        
        set_time_limit(10000000);

        $upload = @self::incluiAnexosEvolucaoCRM($nrorg, $nrseqevolcont);

        if ($upload === true) {
            tk_message('Arquivo anexado com sucesso');
            self::atualizaAnexosCRM($nrseqevolcont);
            tk_save_row();
            tk_reload_data_with_filter();
            return true;
        } else {
            tk_message('Erro ao Anexar o arquivo', 'ERROR');
            return false;
        } 
    }


// É uma função que abre uma popup perguntando se deseja apagar os anexos selecionados, se o usuario escolher SIM ai é chamado a função deletaAnexoCRM.
    public static function tkConfirmCRM($nrorg, $nrseqevolcont){
        $listArq = tk_get_field_value('checkArquivo');
        $mensagem = tk_get_message_by_name('msg_desejaExcluirArquivos');
        $sim = array(
            "label" => tk_get_message_by_name("msg_confirmar"),
            "method" => array("\\Relatione\\Logic\\AnexosCrmLogic", "deletaAnexoCRM"),
            'params_arr' => array($nrorg,$nrseqevolcont,$listArq)
        );

        $nao = array("label" => tk_get_message_by_name("msg_cancelar"));

        tk_confirm($mensagem, $sim, $nao);

    }

//Quando um registro de evolução é deletado a pasta de anexos com sua chave de evolução é excluida atraves desta função.
    public static function deletaPastaAnexoEvol($nrorg, $nrseqevolcont)
    {
      $listArq = tk_get_field_value('checkArquivo');
      tk_set_env_var('PASTAS_EVOL',true);
      @self::deletaAnexoCRM($nrorg, $nrseqevolcont, $listArq);
    }



//Função que exclui diretório com todos seus arquivos e subpastas.
public static function ExcluiPastaAnexo($caminho){
    
    if ($dir = opendir($caminho)) {
        while (false !== ($Arq = readdir($dir))) {
            if($Arq != "." && $Arq != ".."){
                $Path = "$caminho/$Arq";
                if(is_dir($Path)){
                    ExcluiPastaAnexo($Path);
                }elseif(is_file($Path)){
                    unlink($Path);
                }
            }
        }
        closedir($dir);
    }
    rmdir($caminho);
}

}